local user
local YGSmainFrame
local YGSbuttonFrame = {}
local YGSeditFrame = {}
local YGScheckFrame = {}
local CurrentDB = {}
local FilteredDB = {}
local YGSnumframes = 0


local GUIFramePool = {}
local GUIFrameScriptHandler = {     
	'OnChar',
	'OnEnter',
	'OnHide',
	'OnKeyDown',
	'OnKeyUp',
	'OnLeave',
	'OnMouseDown',
	'OnMouseUp',
	'OnMouseWheel',
	'OnShow',
	'OnCursorChanged',
	'OnEnterPressed',
	'OnEscapePressed',
	'OnTabPressed',
	'OnTextChanged',
	'OnTextSet',
	'OnClick'
}

function YssGuildShop:RecycleFrame(frame)
	if frame then
		frame:UnregisterAllEvents()
		frame:ClearAllPoints()
		frame:Hide()
		for k,v in ipairs(GUIFrameScriptHandler) do
			if frame:HasScript(v) then 
				frame:SetScript(v, nil)
			end
		end
		local frameType = frame:GetObjectType();
		GUIFramePool[frameType] = GUIFramePool[frameType] or {}
		tinsert(GUIFramePool[frameType], frame)
	end
end

function YssGuildShop:GetNewFrame(frameType, frameParent)
	local newFrame
	local fs
	if GUIFramePool[frameType] and #GUIFramePool[frameType] > 0 then
		newFrame = tremove(GUIFramePool[frameType]) --removes from front instead of back to prevent justification to be screwed up
		newFrame:SetParent(frameParent)
	else
		YGSnumframes = YGSnumframes + 1
		newFrame = CreateFrame(frameType, "YGSFrame"..YGSnumframes, frameParent)
		if frameType == "Button" then
			fs = newFrame:CreateFontString("myFS", "OVERLAY", "GameFontHighlight")
			newFrame:SetFontString(fs)
			fs:SetAllPoints(newFrame)
		end
	end
	return newFrame
end


--Handles enableing/disabling the tab buttons and Generating the DewDropMenu
function YssGuildShop:ChangeView(viewType)
	local numGuildTotal = GetNumGuildMembers(true)
	local YGS_dp_counter = 0
	local sorter = {}
	P_drop_menu={}
	YGSPersonal:Enable()
	YGSBank:Enable()
	YGSGuild:Enable()
	YGSFilter:Enable()
	getglobal(viewType):Disable()
	YGS_Personel_dew:Close()
	if viewType == "YGSPersonal" then
		for k,v in ipairs(YssGuildShop.db.account.YGSDB) do
			if v["YGS_ID"][1] ~= UnitName("player")  or v["YGS_ID"][4] ~= GetRealmName() then
				YGS_dp_counter = YGS_dp_counter + 1
				sorter[YGS_dp_counter] = v["YGS_ID"][1].." ("..v["YGS_ID"][4]..")"
			end
		end
		YGS_name_Text1:SetText("Personal Data")
	elseif viewType == "YGSBank" then
		if YssGuildShop.db.char.YGS_share then
			for k,v in ipairs(YssGuildShop.db.char.YGS_share) do
				for j=1,numGuildTotal do
					local name, _, rankIndex = GetGuildRosterInfo(j)
					--YssGuildShop:Print(name) -- debugline
					if tostring(name) == tostring(v["YGS_ID"][1]) and YssGuildShop.db.char.YGS_permission[rankIndex+1][1] then
						--YssGuildShop:Print(rankIndex) -- debugline
						YGS_dp_counter = YGS_dp_counter + 1
						sorter[YGS_dp_counter] = v["YGS_ID"][1]
					end
				end
			end
		end
		YGS_name_Text1:SetText("Bank Data")
	elseif viewType == "YGSGuild" then
		if YssGuildShop.db.char.YGS_share then
			for k,v in ipairs(YssGuildShop.db.char.YGS_share) do
				for j=1,numGuildTotal do
					local name, _, rankIndex = GetGuildRosterInfo(j)
					--YssGuildShop:Print(name) -- debugline
					if tostring(name) == tostring(v["YGS_ID"][1]) and not YssGuildShop.db.char.YGS_permission[rankIndex+1][1] then
						--YssGuildShop:Print(rankIndex) -- debugline
						YGS_dp_counter = YGS_dp_counter + 1
						sorter[YGS_dp_counter] = v["YGS_ID"][1]
					end
				end
			end
		end
		YGS_name_Text1:SetText("Guild Data")
	elseif viewType == "YGSFilter" then
		-- we shall seee about this
		YGS_name_Text1:SetText("Filter Data")
	end
	table.sort(sorter)
	for k,v in ipairs(sorter) do
		P_drop_menu[k] = {
			text = v,
			func = function()
				self:GenerateFrame(viewType, v, nil)
				YGS_Personal_Name_Drop_field:SetText(v)
				YGS_Personel_dew:Close()
				YGS_Personal_Search:SetText("")
			end
		}
	end
	if viewType == "YGSPersonal" then
		if table.maxn(P_drop_menu) > 0 then
			table.insert(P_drop_menu, 1, {
				text = UnitName("player").." ("..GetRealmName()..")",
				func = function()
					self:GenerateFrame(viewType, UnitName("player").." ("..GetRealmName()..")", nil)
					YGS_Personal_Name_Drop_field:SetText(UnitName("player").." ("..GetRealmName()..")")
					YGS_Personel_dew:Close()
					YGS_Personal_Search:SetText("")
				end
			})
			table.insert(P_drop_menu, 2, { 
				text = "------------------------------",
				isTitle = true
			})
		else
			P_drop_menu[table.maxn(P_drop_menu)] = {
				text = UnitName("player").." ("..GetRealmName()..")",
				func = function()
					self:GenerateFrame(viewType, UnitName("player").." ("..GetRealmName()..")", nil)
					YGS_Personal_Name_Drop_field:SetText(UnitName("player").." ("..GetRealmName()..")")
					YGS_Personel_dew:Close()
					YGS_Personal_Search:SetText("")
				end
			}
		end
		user = UnitName("player").." ("..GetRealmName()..")"
		YGS_Personal_Name_Drop_field:SetText(user)
		YssGuildShop:GenerateFrame(viewType, user, nil)
	elseif sorter[1] then
		user = sorter[1]
		YGS_Personal_Name_Drop_field:SetText(user)
		YssGuildShop:GenerateFrame(viewType, user, nil)
	else
		YGS_Personal_Name_Drop_field:SetText("")
	end
	self:GenerateFrame(viewType, user, "")
end


function YssGuildShop:GenerateFrame(viewType, user, filter)
	
	--Recycle all frames and make them available for regeneration
	self:RecycleFrame(YGSmainFrame)
	YGSmainFrame = nil
	for k,v in ipairs(YGSbuttonFrame) do
		self:RecycleFrame(YGSbuttonFrame[k]);
		YGSbuttonFrame[k] = nil;
	end
	for k,v in ipairs(YGSeditFrame) do
		self:RecycleFrame(YGSeditFrame[k]);
		YGSeditFrame[k] = nil;
	end
	for k,v in ipairs(YGScheckFrame) do
		self:RecycleFrame(YGScheckFrame[k]);
		YGScheckFrame[k] = nil;
	end
	YGSbuttonFrame = {}
	YGSeditFrame = {}
	YGScheckFrame = {}
	if viewType and user then
		--Setting Up the Database to be used to display the info
		CurrentDB = {}
		if viewType == "YGSPersonal" then
			-- breaks down the personal user in its name and realm components
			local argv = {};
			for arg in string.gmatch(user, '[%a]+') do
				table.insert(argv, arg);
			end
			local name = rawget(argv, 1)
			argv = {};
			for arg in string.gmatch(user, '%b()') do
				table.insert(argv, arg);
			end
			argv[1] = string.gsub(argv[1], "%(", "")
			argv[1] = string.gsub(argv[1], "%)", "")
			local realm = rawget(argv, 1)
			
			--assign the correct DB to the CurrentDB
			for k,v in ipairs(YssGuildShop.db.account.YGSDB) do
				if YssGuildShop.db.account.YGSDB[k]["YGS_ID"][1] == name and YssGuildShop.db.account.YGSDB[k]["YGS_ID"][4] == realm  then
					CurrentDB = YssGuildShop.db.account.YGSDB[k]
				end
			end
		elseif viewType == "YGSBank" or viewType == "YGSGuild" then
			if YssGuildShop.db.char.YGS_share then
				for k,v in ipairs(YssGuildShop.db.char.YGS_share) do
					if YssGuildShop.db.char.YGS_share[k]["YGS_ID"][1] == user then
						CurrentDB = YssGuildShop.db.char.YGS_share[k]
					end
				end
			end
		elseif viewType == "YGSFilter" then
			--will reimplement this later
		end
	end
	
	if CurrentDB ~= {} then
		--remove any data if it dosn't match the filter
		FilteredDB = {}
		if not filter then
			filter = ""
		end
		for i,value in ipairs(CurrentDB) do
			if YssGuildShop_itemID_d(value[1]) then
				if string.find(string.lower(YssGuildShop_itemID_d(value[1])), string.lower(filter)) then
					table.insert(FilteredDB,{YssGuildShop_itemID_L(value[1]),value[2]})
				end
			else
				--YssGuildShop:Print(key) --debug line
				GameTooltip:SetHyperlink("item:"..value[1])
			end
		end
		
		--Generate the ScrollFrame
		local currentFrame = 0
		YGSmainFrame = self:GetNewFrame("Frame", nil)
		YGSmainFrame:SetWidth(525)
		YGSmainFrame:SetHeight(table.maxn(FilteredDB)*16)
		for i,value in ipairs(FilteredDB) do
			if i ~= 1 then
				tinsert(YGSbuttonFrame, self:GetNewFrame("Button", nil))
				currentFrame = table.maxn(YGSbuttonFrame)
				YGSbuttonFrame[currentFrame]:SetParent(YGSmainFrame)
				YGSbuttonFrame[currentFrame]:SetHeight(16)
				YGSbuttonFrame[currentFrame]:SetPoint("TOPLEFT", YGSbuttonFrame[currentFrame-2], "BOTTOMLEFT")
				YGSbuttonFrame[currentFrame]:SetPoint("TOPRIGHT", YGSbuttonFrame[currentFrame-2], "BOTTOMRIGHT")
				YGSbuttonFrame[currentFrame]:GetFontString():SetJustifyH("LEFT")
				YGSbuttonFrame[currentFrame]:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 0, right = 0, top = 0, bottom = 0}})
				if i/2 == math.floor(i/2) then
					YGSbuttonFrame[currentFrame]:SetBackdropColor(0,0,0,.5)
				else
					YGSbuttonFrame[currentFrame]:SetBackdropColor(0,0,0,0)
				end
				YGSbuttonFrame[currentFrame]:SetScript("OnClick", function() YssGuildShop:ItemClick(this:GetText()) end)
				YGSbuttonFrame[currentFrame]:SetText(value[1])
				
				tinsert(YGSbuttonFrame, self:GetNewFrame("Button", nil))
				currentFrame = table.maxn(YGSbuttonFrame)
				YGSbuttonFrame[currentFrame]:SetParent(YGSmainFrame)
				YGSbuttonFrame[currentFrame]:SetPoint("TOPRIGHT", YGSbuttonFrame[currentFrame-2], "BOTTOMRIGHT")
				YGSbuttonFrame[currentFrame]:SetPoint("BOTTOMLEFT", YGSbuttonFrame[currentFrame-1], "BOTTOMRIGHT")
				YGSbuttonFrame[currentFrame]:GetFontString():SetJustifyH("RIGHT")
				YGSbuttonFrame[currentFrame]:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 0, right = 0, top = 0, bottom = 0}})
				if i/2 == math.floor(i/2) then
					YGSbuttonFrame[currentFrame]:SetBackdropColor(0,0,0,.5)
				else
					YGSbuttonFrame[currentFrame]:SetBackdropColor(0,0,0,0)
				end
				YGSbuttonFrame[currentFrame]:SetText(value[2])
				
			else
				tinsert(YGSbuttonFrame, self:GetNewFrame("Button", nil))
				currentFrame = table.maxn(YGSbuttonFrame)
				YGSbuttonFrame[currentFrame]:SetParent(YGSmainFrame)
				YGSbuttonFrame[currentFrame]:SetHeight(16)
				YGSbuttonFrame[currentFrame]:SetWidth(430)
				YGSbuttonFrame[currentFrame]:SetPoint("TOPLEFT", YGSmainFrame, "TOPLEFT")
				YGSbuttonFrame[currentFrame]:GetFontString():SetJustifyH("LEFT")
				YGSbuttonFrame[currentFrame]:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 0, right = 0, top = 0, bottom = 0}})
				if i/2 == math.floor(i/2) then
					YGSbuttonFrame[currentFrame]:SetBackdropColor(0,0,0,.5)
				else
					YGSbuttonFrame[currentFrame]:SetBackdropColor(0,0,0,0)
				end
				YGSbuttonFrame[currentFrame]:SetScript("OnClick", function() YssGuildShop:ItemClick(this:GetText()) end)
				YGSbuttonFrame[currentFrame]:SetText(value[1])
				
				tinsert(YGSbuttonFrame, self:GetNewFrame("Button", nil))
				currentFrame = table.maxn(YGSbuttonFrame)
				YGSbuttonFrame[currentFrame]:SetParent(YGSmainFrame)
				YGSbuttonFrame[currentFrame]:SetPoint("TOPRIGHT", YGSmainFrame, "TOPRIGHT")
				YGSbuttonFrame[currentFrame]:SetPoint("BOTTOMLEFT", YGSbuttonFrame[currentFrame-1], "BOTTOMRIGHT")
				YGSbuttonFrame[currentFrame]:GetFontString():SetJustifyH("RIGHT")
				YGSbuttonFrame[currentFrame]:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 0, right = 0, top = 0, bottom = 0}})
				if i/2 == math.floor(i/2) then
					YGSbuttonFrame[currentFrame]:SetBackdropColor(0,0,0,.5)
				else
					YGSbuttonFrame[currentFrame]:SetBackdropColor(0,0,0,0)
				end
				YGSbuttonFrame[currentFrame]:SetText(value[2])
			end
		end
		YGSmainFrame:Show()
		for i,value in ipairs(YGSbuttonFrame) do
			YGSbuttonFrame[i]:Show()
		end
		YGS_Scroll:SetScrollChild(YGSmainFrame)
		YGS_Scroll:UpdateScrollChildRect()
	end
end

function YssGuildShop:ItemClick(link)
	if IsShiftKeyDown() then
		ChatFrameEditBox:SetText(ChatFrameEditBox:GetText()..link)
	elseif IsControlKeyDown() then
		DressUpItemLink(link)
	else
		SetItemRef(link, link, 'LeftButton')
	end
end

function YGS_onclick(link)
	if IsShiftKeyDown() then
		ChatFrameEditBox:SetText(ChatFrameEditBox:GetText()..link)
	elseif IsControlKeyDown() then
		DressUpItemLink(link)
	else
		SetItemRef(link, link, 'LeftButton')
	end
end
